/*
   =============================================================================
	stmproc.c -- external declarations
   =============================================================================
*/

#pragma once

#include "patch.h"
#include "stdint.h"
#include "wordq.h"

/*
   =============================================================================
	external variables
   =============================================================================
*/

extern	struct	defent	defents[RAWDEFS];
extern	int8_t		defptr[NDEFSTMS];
extern	int8_t		dmatch[];
extern	uint16_t	dpecpos;
extern	uint16_t	dpepred;
extern	uint16_t	dpesucc;
extern	uint16_t	dtfree;
extern	struct	patch	patches[MAXPATCH];
extern	int8_t		ptdsbuf[50];
extern	struct	wordq	ptefifo;
extern	uint16_t	ptewrds[NPTEQELS];
extern	uint16_t	ptfree;
extern	int8_t		stmptr[NDEFSTMS];

/*
   =============================================================================
	external functions
   =============================================================================
*/

extern	int16_t		cprdpe(uint16_t np);
extern	int16_t		cprpte(uint16_t np);
extern	void		dpte(int16_t pe, int16_t row, int16_t atr);
extern	void		dptw(void);
extern	uint16_t	dt_alc(void);
extern	void		dt_del(uint16_t de);
extern	void		entrpte(void);
extern	int16_t		find1st(void);
extern	int16_t		finddpe(void);
extern	int16_t		findnxt(int16_t cp);
extern	int16_t		findprv(int16_t cp);
extern	int16_t		findpte(void);
extern	void		initpt(void);
extern	uint16_t	pt_alc(void);
extern	void		pt_del(uint16_t pe);
extern	void		srdspte(void);
extern	void		stmproc(uint16_t trg);
